unit Item;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask;

type
  TItemFrm = class(TForm)
    ItemPanel: TPanel;
    StrEd: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ItemBtn: TButton;
    ExitBtn: TButton;
    ItemEd: TMaskEdit;
    DelBtn: TButton;
    LonEd: TMaskEdit;
    LatEd: TMaskEdit;
    procedure ItemEdExit(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ItemBtnClick(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ItemFrm: TItemFrm;

implementation

{$R *.DFM}
 Uses Pm,PmUtil;

procedure TItemFrm.ItemEdExit(Sender: TObject);
Var Cntr : Integer;
begin
Cntr := StrToIntDef(Trim(ItemEd.text),1);
if Cntr > High(ItemRec) then Cntr := High(ItemRec);
 if Cntr = 0 then Cntr := 1;
 ItemCntr := Cntr-1;

 With ItemRec[ItemCntr] do
 Begin
  ItemEd.Text := IntToStr(Cntr);
  if (Lon = 0) or (Lat = 0) then
  Begin
   Lon := FstrRec.LonCtr;
   Lat := FstrRec.LatCtr;
  End;
  LonEd.Text := FloatToStr(Lon);
  LatEd.text := FloatToStr(Lat);
  StrEd.text := Comment;
 End;
end;

procedure TItemFrm.ExitBtnClick(Sender: TObject);
begin
 Close;
end;

procedure TItemFrm.FormActivate(Sender: TObject);
begin
  ItemEd.text := IntToStr(ItemCntr+1);
  LonEd.text :=  FloatToStr(ItemRec[ItemCntr].Lon);
  LatEd.text :=  FloattoStr(ItemRec[ItemCntr].Lat);
  StrEd.text := ItemRec[ItemCntr].Comment;
end;

procedure TItemFrm.ItemBtnClick(Sender: TObject);
begin
 With ItemRec[ItemCntr] do
 Begin
  Lon := StrToFloat(Trim(LonEd.text));
  Lat := StrToFloat(Trim(LatEd.text));
  Comment := StrEd.text;

  If Lon > 0 then Lon := Lon *-1;      // Must be negative or West in US

  if (Lon <> 0) and (Lat <> 0) then
  With Main.OlePmMap1 do
  Begin
   SetItem(ItemCntr,Lon,Lat);          // Initializes or moves item

   If Odd(ItemCntr) then               // A little variety in vehicles
    //SetItemLocalBitMap(ItemCntr,ExtractFilePath(Application.ExeName) + 'RedTrk.Bmp')
     SetItemBitMap(ItemCntr,Main.BmpImg1.Picture.Bitmap.Handle)

   else
   // SetItemLocalBitMap(ItemCntr,ExtractFilePath(Application.ExeName) + 'RedCar.Bmp');
    SetItemBitMap(ItemCntr,Main.BmpImg2.Picture.Bitmap.Handle);

    SetItemString(ItemCntr,comment);   // Assigns label. If blank then no label

    AutoPaint := False;                // Multiple instructions before redrawing
    If Miles > 0.1 then Miles := 0.1;  // Zoom in if necessary
    GoToPoint(Lon,Lat);                // Centers map on Item
    AutoPaint := True;
    Redraw;                            // Previous instructions take effect here
   End;
 End;
end;

procedure TItemFrm.DelBtnClick(Sender: TObject);
begin
 With ItemRec[ItemCntr] do
 Begin
  Main.OlePmMap1.DeleteItem(ItemCntr);   // Deletes item from PmMap and display
  Main.OlePmMap1.Refresh;
 End;
end;

end.
