unit Properties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,iniFiles, ComCtrls;

type
  TPropFrm = class(TForm)
    PropDlg: TOpenDialog;
    PageC: TPageControl;
    PathSheet: TTabSheet;
    Data1Ed: TEdit;
    Data2Ed: TEdit;
    Data3Ed: TEdit;
    StatesEd: TEdit;
    ContourEd: TEdit;
    PmapBtn: TButton;
    MapBtn: TButton;
    CurrentBtn: TButton;
    Properties: TTabSheet;
    Panel1: TPanel;
    SaveBtn: TButton;
    CloseBtn: TButton;
    AutoPntChk: TCheckBox;
    AutoQueryChk: TCheckBox;
    BackDrawChk: TCheckBox;
    EdgePanChk: TCheckBox;
    EnabledChk: TCheckBox;
    GridChk: TCheckBox;
    MainLayChk: TCheckBox;
    OverLayChk: TCheckBox;
    UnderLayChk: TCheckBox;
    LdAirChk: TCheckBox;
    LdCityChk: TCheckBox;
    LdCntyChk: TCheckBox;
    LdHighWayChk: TCheckBox;
    LdHydroChk: TCheckBox;
    LdLandMarkChk: TCheckBox;
    LdStateChk: TCheckBox;
    VisibleChk: TCheckBox;
    ShCntyChk: TCheckBox;
    ShMCDChk: TCheckBox;
    ShPlcChk: TCheckBox;
    ShStateChk: TCheckBox;
    UnderLayEd: TEdit;
    CurrentProp: TButton;
    CfgEd: TEdit;
    TabSheet1: TTabSheet;
    LonLeftEd: TEdit;
    LatTopEd: TEdit;
    LonRightEd: TEdit;
    LatBottomEd: TEdit;
    MapCurBth: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    AspectEd: TEdit;
    MagEd: TEdit;
    ScaleEd: TEdit;
    MilesEd: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    RedrawBtn: TButton;
    RefreshBtn: TButton;
    LoadBtn: TButton;
    ShadeBtn: TButton;
    RestoreBtn: TButton;
    procedure PmapBtnClick(Sender: TObject);
    procedure MapBtnClick(Sender: TObject);
    procedure CurrentBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CurrentPropClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure MapCurBthClick(Sender: TObject);
    procedure RedrawBtnClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure ShadeBtnClick(Sender: TObject);
    procedure RestoreBtnClick(Sender: TObject);
    procedure AspectEdKeyPress(Sender: TObject; var Key: Char);
    procedure MagEdKeyPress(Sender: TObject; var Key: Char);
    procedure ScaleEdKeyPress(Sender: TObject; var Key: Char);
    procedure MilesEdKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }

  public
    { Public declarations }
      Procedure GetOcxProperties;
    Procedure GetCfgProperties(Fname : String);
    Procedure SetOcxProperties;
  end;

var
  PropFrm: TPropFrm;

implementation
 Uses Pm,PmUtil;
{$R *.DFM}

 Procedure TPropFrm.GetOcxProperties;
 Begin
    With Main.OlePmMap1 do  // Show the paths at load time
  Begin
   If Path_Data1 <> '' Then Data1Ed.text := Path_Data1;
   If Path_Data2 <> '' Then Data2Ed.text := Path_Data2;
   If Path_Data3 <> '' Then Data3Ed.text := Path_Data3;
   If Path_States <> '' Then StatesEd.text := Path_States;
   If UnderlayFile <> '' Then ContourEd.text := UnderLayFile;
   AutoPntChk.Checked := AutoPaint;
   AutoQueryChk.Checked := AutoQuery;
   BackDrawChk.Checked := BackDraw;
   EdgePanChk.Checked := EdgePan;
   EnabledChk.Checked := Enabled;
   GridChk.Checked := Grid;
   MainLayChk.Checked := MainLay;
   OverLayChk.Checked := OverLay;
   UnderLayChk.Checked := UnderLay;
   VisibleChk.Checked := Visible;
   LdAirChk.Checked := Load_Air;
   LdCityChk.Checked := Load_City;
   LdCntyChk.Checked := Load_County;
   LdHighWayChk.Checked := Load_Highway;
   LdHydroChk.Checked := Load_Hydro;
   LdLandMarkChk.Checked := Load_LandMark;
   LdStateChk.Checked := Load_State;
   ShCntyChk.Checked := Shade_Cnty;
   ShMCDChk.Checked := Shade_MCD;
   ShPlcChk.Checked := Shade_Plc;
   ShStateChk.Checked := Shade_State;
   UnderLayEd.Text := UnderLayFile;
   LonLeftEd.Text := FloatToStrF(LonLeft,fffixed,8,6);
   LonRightEd.Text := FloatToStrF(LonRight,fffixed,8,6);
   LatTopEd.text := FloatToStrF(LatTop,fffixed,8,6);
   LatBottomEd.Text := FloatToStrF(LatBottom,fffixed,8,6);
   MilesEd.Text := FloatToStrF(Miles,ffFixed,6,2);
   MagEd.Text := IntToStr(Magnitude);
   ScaleEd.Text := FloatToStrf(Scale,ffFixed,8,4);
   AspectEd.Text := FloattoStrF(Screen_Aspect,ffFixed,4,4);
  End;
 End;  // GetOcxProperties

 Procedure TPropFrm.GetCfgProperties(Fname : String);
  var
    ConFigfile : TiniFile;
    SatStr,Cstr : String;
    SatFile : TextFile;
    Err : Word;
  Begin
  Try
   Try

    ConFigfile := TiniFile.create(FName);

   With Main.OlePmMap1,ConFigfile do
   Begin
    StatesEd.Text := Configfile.ReadString('Directories','CdState','');
    Data1Ed.Text := ReadString('Directories','CdData1','');
    Data2Ed.Text  := ReadString('Directories','CdData2','');
    Data3Ed.Text := ReadString('Directories','CdData3','');
    ContourEd.Text := ExtractFilePath(ReadString('Directories','CdCont',IniRec.Contour));
    AspectEd.Text := ReadString('Modules','ASP','1.0');
    MainLayChk.Checked := ReadBool('Overlays','LMain',True);
    LdHydroChk.Checked := ReadBool('OverLays','LHydro',True);
    LdHighWayChk.Checked := ReadBool('Overlays','LHNET',True);
    LdStateChk.Checked := ReadBool('OverLays','LSTATE',True);
    LdCityChk.Checked := ReadBool('OverLays','LCITY',True);
    LdAirChk.Checked := ReadBool('Overlays','LAIR',True);
    LdLandMarkChk.Checked := ReadBool('Overlays','LLAND',True);
    LdCntyChk.Checked := ReadBool('Overlays','LCNTY',True);
    AutoQueryChk.Checked := ReadBool('Options','HINT',True);
    ShCntyChk.Checked := ReadBool('Shades','CNTYON',True);
    ShMCDChk.Checked := ReadBool('Shades','MCDON',True);
    ShPlcChk.Checked := ReadBool('Shades','PLCON',True);
    ShStateChk.Checked := ReadBool('Shades','STATEON',True);




   End;

  except
    messagedlg('Config Read Error ' + Chr(10) ,mterror,[mbok],0);
  end;
 Finally
  ConfigFile.Free;

 End;
 End;  //  GetOcxProperties


 Procedure TPropFrm.SetOcxProperties;
 Begin
     With Main.OlePmMap1 do  // Show the paths at load time
  Begin
   If (Length(Trim(Data1Ed.Text)) < 4) or
      (Length(Trim(Data2Ed.Text)) < 4) or
      (Length(Trim(Data3Ed.Text)) < 4) or
      (Length(Trim(StatesEd.Text)) < 4) Then
      If MessageDlg('One or more data paths has not been set!' + #13 +
              'Save anyway?',MtConfirmation,[MbYes,MbNo],0) <> mrYes then exit;

   Path_Data1 := Trim(Data1Ed.text);
   Path_Data2 := Trim(Data2Ed.text);
   Path_Data3 := (Data3Ed.text);
   Path_States := Trim(StatesEd.text);
   UnderLayFile := Trim(ContourEd.text);

   AutoPaint := AutoPntChk.Checked;
   AutoQuery := AutoQueryChk.Checked;
   BackDraw := BackDrawChk.Checked;
   EdgePan := EdgePanChk.Checked;
   Enabled := EnabledChk.Checked;
   Grid := GridChk.Checked;
   MainLay := MainLayChk.Checked;
   OverLay := OverLayChk.Checked;

   Visible := VisibleChk.Checked;
   Load_Air := LdAirChk.Checked;
   Load_City := LdCityChk.Checked;
   Load_County := LdCntyChk.Checked;
   Load_HighWay := LdHighWayChk.Checked;
   Load_Hydro := LdHydroChk.Checked;
   Load_LandMark := LdLandMarkChk.Checked;
   Load_State := LdStateChk.Checked;
   Shade_Cnty := ShCntyChk.Checked;
   Shade_MCD := ShMCDChk.Checked;
   Shade_Plc := ShPlcChk.Checked;
   Shade_State := ShStateChk.Checked;
   UnderLayFile := Trim(UnderLayEd.Text);
   UnderLay := UnderLayChk.Checked;

    Main.Hydro1.Checked := Load_Hydro;   // Menu item
    Main.Highway1.Checked := Load_Highway;
    Main.County1.Checked := Load_County;
    Main.State1.checked := Load_State;
    Main.City1.Checked := Load_City;
    Main.Air1.Checked := Load_Air;
    Main.LandMark1.Checked := Load_LandMark;
    Main.EnhancedRedraw1.Checked := BackDraw;
    Main.AutoQuery1.Checked := AutoQuery;
    Main.LoadLastView1.Checked := SaveView;
    Main.Overlay1.Checked := OverLay;
    Main.Grid1.Checked := Grid;
    Main.AutoPaint1.Checked := AutoPaint;

    If Length(Trim(CfgEd.text)) > 3 then
     IniRec.PmMapCfg := CfgEd.Text;
    AutoPaint := False;
   If (Trim(AspectEd.text) <> '') Then  Screen_Aspect := StrToFloat(Trim(AspectEd.Text));
   If (Trim(MagEd.text) <> '') Then  Magnitude := StrToIntDef(Trim(MagEd.Text),11);
   If (Trim(ScaleEd.text) <> '') Then  Scale := StrToFloat(Trim(ScaleEd.Text));
   If (Trim(MilesEd.text) <> '') Then  Miles := StrToFloat(Trim(MilesEd.Text));
   AutoPaint := AutoPntChk.Checked;
  End;

 End;  // SetOcxProperties

procedure TPropFrm.PmapBtnClick(Sender: TObject);
begin
 If Pos('PMAP.CFG',UpperCase(IniRec.PmMapCfg)) > 0 Then
 PropDlg.FileName := IniRec.PmMapCfg
 else
 PropDlg.Filename := 'Pmap.Cfg';

 If PropDlg.Execute then
 Begin
  CfgEd.Text := PropDlg.Filename;
  GetCfgProperties(PropDlg.FileName);
 End;
end;

procedure TPropFrm.MapBtnClick(Sender: TObject);
begin
PropDlg.Filename := ExtractFilePath(Application.Exename)+'MapOcx.Cfg';
 If PropDlg.Execute then
 Begin
   CfgEd.Text := PropDlg.Filename;
  GetCfgProperties(PropDlg.FileName);
 end;
End;

procedure TPropFrm.CurrentBtnClick(Sender: TObject);
begin
  With Main.OlePmMap1 do
  Begin
   Data1Ed.Text := Path_Data1;
   Data2Ed.Text := Path_Data2;
   Data3Ed.Text := Path_Data3;
   StatesEd.Text := Path_States;
   ContourEd.Text := UnderLayFile;

  End;
end;

procedure TPropFrm.FormCreate(Sender: TObject);

begin
  GetOcxProperties;
end;

procedure TPropFrm.CurrentPropClick(Sender: TObject);
begin
 GetOcxProperties;
end;

procedure TPropFrm.SaveBtnClick(Sender: TObject);
begin
 SetOcxProperties;
 GetOcxProperties;
end;

procedure TPropFrm.CloseBtnClick(Sender: TObject);
begin
 Close;
end;

procedure TPropFrm.MapCurBthClick(Sender: TObject);
begin
With Main.OlePmMap1 do
 Begin
   LonLeftEd.Text := FloatToStrF(LonLeft,fffixed,8,6);
   LonRightEd.Text := FloatToStrF(LonRight,fffixed,8,6);
   LatTopEd.text := FloatToStrF(LatTop,fffixed,8,6);
   LatBottomEd.Text := FloatToStrF(LatBottom,fffixed,8,6);
   MilesEd.Text := FloatToStrF(Miles,ffFixed,6,2);
   MagEd.Text := IntToStr(Magnitude);
   ScaleEd.Text := FloatToStrf(Scale,ffFixed,8,4);
   AspectEd.Text := FloattoStrF(Screen_Aspect,ffFixed,4,4);
  End;
end;

procedure TPropFrm.RedrawBtnClick(Sender: TObject);
begin
 Main.OlePmMap1.Redraw;
end;

procedure TPropFrm.RefreshBtnClick(Sender: TObject);
begin
 Main.OlePmMap1.Refresh;
end;

procedure TPropFrm.LoadBtnClick(Sender: TObject);
begin
 LdAirChk.Checked := Not LdAirChk.Checked;
 LdCityChk.Checked := LdAirChk.Checked;
 LdCntyChk.Checked := LdAirChk.Checked;
 LdHighwayChk.Checked := LdAirChk.Checked;
 LdHydroChk.Checked := LdAirChk.Checked;
 LdLandMarkChk.Checked := LdAirChk.Checked;
 LdStateChk.Checked := LdAirChk.Checked;
end;

procedure TPropFrm.ShadeBtnClick(Sender: TObject);
begin
 ShCntyChk.Checked := Not ShCntyChk.Checked;
 ShMCDChk.Checked := ShCntyChk.Checked;
 ShPLCChk.Checked := ShCntyChk.Checked;
 ShStateChk.Checked := ShCntyChk.Checked;
end;

procedure TPropFrm.RestoreBtnClick(Sender: TObject);
begin
GetOcxProperties;
end;

procedure TPropFrm.AspectEdKeyPress(Sender: TObject; var Key: Char);
begin
  If key = #13 then
 Begin
  Aratio := StrToFloat(AspectEd.text);
  If Aratio > 1.9 then exit;
 If Aratio <> Main.OlePmMap1.Screen_Aspect then
  Begin
   Main.OlePmMap1.Screen_Aspect := Aratio;
   Main.OlePmMap1.Redraw;  // Must redraw
   Main.AratioEd.Text := FloatToStrF(Main.OlePmMap1.Screen_Aspect,ffFixed,3,2);
   Application.ProcessMessages;
   GetOcxProperties;
  End;
  Key := #0;
 End
 Else
  If (Key > #32) And (Key < #127) And (Pos(key,'0123456789.')=0) then Key := #0;
end;

procedure TPropFrm.MagEdKeyPress(Sender: TObject; var Key: Char);
begin
 If key = #13 then
 With Main.OlePmMap1 do
 Begin
  if StrToIntDef(MagEd.text,0)<> 0 Then
  if StrToInt(MagEd.text) <> Magnitude then
   Magnitude := StrToIntDef(MagEd.Text,Magnitude);
   Application.ProcessMessages;
   GetOcxProperties;
  Key := #0;
 End
 Else
  If (Key > #32) And (Key < #127) And (Pos(key,'0123456789.')=0) then Key := #0;
end;


procedure TPropFrm.ScaleEdKeyPress(Sender: TObject; var Key: Char);
Var Sc : Double;
begin
 If key = #13 then
 Begin
  Sc := StrToFloat(ScaleEd.text);
 If Sc <> Main.OlePmMap1.Scale then
  Begin
   Main.OlePmMap1.Scale := Sc;
   Main.OlePmMap1.Redraw;  // Must redraw
   Application.ProcessMessages;
   GetOcxProperties;
  End;
  Key := #0;
 End
 Else
  If (Key > #32) And (Key < #127) And (Pos(key,'0123456789.')=0) then Key := #0;
end;

procedure TPropFrm.MilesEdKeyPress(Sender: TObject; var Key: Char);
Var Mi : Double;
begin
 If key = #13 then
 Begin
  Mi := StrToFloat(MilesEd.text);
 If Mi <> Main.OlePmMap1.Miles then
  Begin
   Main.OlePmMap1.Miles := Mi;
   Main.OlePmMap1.Redraw;  // Must redraw
   Application.ProcessMessages;
   GetOcxProperties;
  End;
  Key := #0;
 End
 Else
  If (Key > #32) And (Key < #127) And (Pos(key,'0123456789.')=0) then Key := #0;
end;

end.
